<?php

/**
 * @brief   Subdirectory aware directory iterator.
 * @author  Marcus Boerger
 * @version 1.0
 *
 * This directory iterator recursively returns all files and directories
 * within a given path.
 */
class DirectoryFilterDotsRecursive extends DirectoryFilterDots implements RecursiveIterator
{
	function hasChildren()
	{
		return !$this->getInnerIterator()->isDot() && $this->getInnerIterator()->isDir();
	}
	
	function getChildren()
	{
		return new DirectoryFilterDotsRecursive($this->getInnerIterator()->getPath() . '/' . $this->current());
	}
	
	function accept()
	{
		return !$this->getInnerIterator()->isDot();
	}
}

?>